#!/usr/bin/perl -w

#./grid-hit-end.pl -i CNIO-Final/protdb -o CNIO-Final/protdb.out -S 20 

print "Grid-HIT Postprocess Script - DSA Group\n";
print "[I] Merging Databases\n";

use strict;
no strict "refs";

my $arg;
my $in;
my $out;
my $arg_pass        = "";
my $para            = "";
my $host_no         = 0;
my @hosts           = ();
my $cd_hit_div_exe  = "./cd-hit-div";
my $cd_hit_exe      = "./cd-hit";
my $cd_hit_2d_exe   = "./cd-hit-2d";
my $clstr_merge_exe = "./clstr_merge.pl";
my $seg_no          = 64;
my $log_file        = "";
my $restart_in      = "";
#my $pbs             = 1;

my $pwd = `pwd`; chop($pwd);

while ($arg=shift) {
  if    ($arg eq "-i")       { $in         = shift; }
  elsif ($arg eq "-o")       { $out        = shift; }
  elsif ($arg eq "-B")       { $para       = shift; }
  elsif ($arg eq "-S")       { $seg_no     = shift; }
#  elsif ($arg eq "-pbs")     { $pbs        = shift; }
  elsif ($arg eq "-restart") { $restart_in = shift;}
  else  {            $arg_pass .= " $arg " . shift; }
}
($in and $out) || die "not input or output";

$log_file = "$out.LOGG";

my $restart_file = "$out.restart";
my $indiv        = "$in.div";
my @commands       = ();
my @command_status = ();
my $command_no     = 0;
my $cmd;
my ($i, $j, $k, $i1, $j1, $k1);
my $iprev;

print "[i] This is GRID-HIT. The GridWay Team.\n";

my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime(time);
printf "%4d-%02d-%02d %02d:%02d:%02d\n",$year+1900,$mon+1,$mday,$hour,$min,$sec;

print "[i] Merging Clusters...\n";


######## merge all .clstr file
my $out_clstr = "$out.clstr";
# if (not -s $out_clstr) {

  my @reps = ();
  for ($i=0; $i<$seg_no; $i++) {
    my $master_clstr = "$indiv-$i-o.clstr";
    die "No file $master_clstr\n" unless (-s $master_clstr);

    my $this_rep = "$indiv-$i-o";
    die "No rep $this_rep\n" unless (-e $this_rep);
    push(@reps, $this_rep);

    my @slave_clstr = ();
    for ($j=$i+1; $j<$seg_no; $j++) {
      my $tclstr = "$indiv-$j.vs.$i.clstr";
      if (-s $tclstr) {push(@slave_clstr,$tclstr); }
      else {die "No file $tclstr\n";}
    }

    if (@slave_clstr) {
      my $tclstrs = join(" ", @slave_clstr);
      print  "$clstr_merge_exe $master_clstr $tclstrs >> $out_clstr\n";
      $cmd = `$clstr_merge_exe $master_clstr $tclstrs >> $out_clstr`;
	print "[i] Done this merging.\n";
    }
    else { #this is the last piece
      print  "cat $master_clstr >> $out_clstr\n";
      $cmd = `cat $master_clstr >> $out_clstr`;    
    }
  }

  my $out_clstr_ren = "$out.clstr.$$";
  open(TMP, $out_clstr) || die;
  open(OTMP, "> $out_clstr_ren") || die;
  my $no = 0;
  my $cno;
  my $ll;
  while($ll=<TMP>){
    if ($ll =~ /^>Cluster (\d+)/) {
      print OTMP ">Cluster $no\n"; $no++;
      $cno  = 0;
    }
    else {
      $ll =~ s/^\d+/$cno/;
      print OTMP $ll;
      $cno++;
    }
  }
  close(TMP);
  close(OTMP);
  sleep(10);
  $cmd = `mv $out_clstr_ren $out_clstr`;

  my $reps = join(" ", @reps);
  $cmd = `cat $reps > $out`;
# }

print "[I] Postprocess Complete!\n";

($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime(time);
printf "%4d-%02d-%02d %02d:%02d:%02d\n",$year+1900,$mon+1,$mday,$hour,$min,$sec;
